/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : couleur.h                        ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Couleur                                                        *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Une couleur est representee par ses trois composantes RVB :           *   
* Rouge, Vert, Bleu                                                     *
*                                                                       *
************************************************************************/
#ifndef _COULEUR_H
#define _COULEUR_H

#include<iostream>

using namespace std;

class Couleur {

private :

	unsigned int rouge;		// composante rouge
	unsigned int vert;		// composante verte	
	unsigned int bleu;		// composante bleue

public :

	// constructeurs
	Couleur() {rouge=0;vert=0;bleu=0;};	// par dfaut -> noir
	Couleur(const Couleur &c) {rouge=c.rouge;vert=c.vert;bleu=c.bleu;};		
	Couleur(const unsigned int &r, const unsigned int &v, const unsigned int &b) {
		// On vrifie que les composantes sont bien comprises entre 0 et 255
		if (r>255) rouge=r%255; else rouge=r;
		if (v>255) vert=v%255; else vert=v;
		if (b>255) bleu=b%255; else bleu=b;
	};

	// destructeur
	~Couleur() {};

	// accesseurs
	unsigned int getRouge() {return rouge;};
	unsigned int getVert() {return vert;};
	unsigned int getBleu() {return bleu;};

	// modificateurs
	void setRouge(const unsigned int r) {if (r>255) rouge=r%255;else rouge=r;};
	void setVert(const unsigned int v) {if (v>255) vert=v%255;else vert=v;};
	void setBleu(const unsigned int b) {if (b>255) bleu=b%255;else bleu=b;};

	// affichage de la couleur
	void afficherInfos() {
		cout<<"("<<rouge<<","<<vert<<","<<bleu<<")"<<endl;
	};
	
	// oprateur d'galit de 2 couleurs
	bool operator == (Couleur coul) {
	    return (coul.getRouge()==rouge) && (coul.getVert()==vert) && (coul.getBleu()==bleu);
  	}
};

#endif
