/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : main.cpp                         ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class:                                                                *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Lance le programme principale. Verfife si la validite des arguments   *   
* passes en parametres.                                                 *
************************************************************************/

#include"menu.h"
#include"scene.h"
#include"sphere.h"
#include"parser.h"
#include"point.h"
#include"vecteur.h"
#include"rayon.h"
#include"lrayons.h"
#include<string>
#include<iostream>

using namespace std;

// programme principal :

// 1. on passe en paramtre le nom du fichier scne XML "fic_scene.xml"
// 2. on "parse" ce fichier afin de crer la scne en mmoire
// 3. on affiche les informations de la scne
// 4. on fait notre lancer de rayons
// 5. le lancer de rayons gnre un fichier "fic_scene.ppm"

int main(int argc, char* argv[]) {
  if(argc==2 && argv[1]!=NULL) {
    Scene *S;
    ifstream xmlfile(argv[1]);
    if (!xmlfile){
      cerr<<"Erreur lors de l ouverture de "<<argv[1]<<"\nNom de fichier invalide"<<endl;
      exit(-1);}
    else{
    S = init(xmlfile);
    S->affiche_scene();
      affiche(S,argv[1]);
  }
  }
  else{
  	cout<<"Passez le nom du fichier scne en paramtre !!!"<<endl;
  }
  return 0;  

}
