/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : parser.cpp                       ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class:                                                                *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Le parser analyse le fichier xml en entre et construits la scene.    *   
* Il tient compte de certaines erreurs de syntaxe.                      *
************************************************************************/

#include "parser.h"

// fonction de renvoi d'un message d'erreur
void syntaxe_erreur(int nolig, string line){
  cout<<"Erreur de syntaxe du fichier xml : "<<nolig<<" "<<line<<endl;
  exit(-1);
}

// conversion d'une chane en flottant
float stof(string s){
  char* chaine = (char*)malloc(sizeof(chaine));
  for(int i=0;i<s.size();i++)chaine[i]=s[i];
  return atof(chaine);
}

// conversion d'une chane en entier
int stoi(string s){
  char* chaine = (char*)malloc(sizeof(chaine));
  for(int i=0;i<s.size();i++)chaine[i]=s[i];
  return atoi(chaine);
}

// analyseur du fichier XML
Scene* init(istream& xfile) { 
  int nolig=0;//numero de ligne
  int i=0,k,l;
  string line,ouverte,param,valeur;
  Pile balises; //le nom de chacune des balises est stock pour l'analyse syntaxique et lexical du fichier
  Scene *S;//pointeur sur la scene creee
  vector<string> variable;//stocke les variables de l'objet courant
  
  
  while(getline(xfile, line)) {
    i=0;             
    //suppression des espaces et tabulations
    while((line[i] == '\t')||(line[i] == ' ')) i++;
  
    nolig++;
    line = line.substr(i,line.size());
    switch (line[1]) {
    case '!' : if(line.substr(3,2)=="--") syntaxe_erreur(nolig,line);break;
      /*sinon il s'agit d'un commentaire*/
    case '?' :break;      
    case '/' : //balise fermante :
      if(balises.empty()) syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante (pile vide)");
      ouverte = balises.top();
      if (ouverte != line.substr(2,ouverte.size())) {                   
	syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante");
	//return false;
      }
      else {                         
	balises.pop();
	if(ouverte=="sphere"){S->ajoutSphere(
					     stof(variable[0]),//abscisse du centre de la sphere
					     stof(variable[1]),//ordonnee du centre de la sphere
					     stof(variable[2]),//cote du centre de la sphere
					     stoi(variable[3]),//composante rouge de la couleur de la sphere
					     stoi(variable[4]),//composante verte de la couleur de la sphere
					     stoi(variable[5]),//composante bleue de la couleur de la sphere
					     stof(variable[6]),//rayon
					     stof(variable[7]),//indmiroir
					     stof(variable[8]),//indiffusion
					     stof(variable[9]),//indspeculaire
					     stoi(variable[10]),//indrugosite
					     stoi(variable[11]),//type de triangulation : 0 parfait, 1 triangulation 1, 2 triangulation 2
					     stoi(variable[12]));variable.clear();};//si type = 1 : nombre de tranches , si type =2 : nombre de cercle du disque de l'quateur
	if(ouverte=="srclum"){S->Scene::ajoutSrcLumiere(
							stof(variable[0]),//abscisse du centre de la source de lumiere
							stof(variable[1]),//ordonnee du centre de la source de lumiere
							stof(variable[2]),//cote du centre de la source de lumiere
							stoi(variable[3]),//composante rouge de la couleur de la source de lumiere
							stoi(variable[4]),//composante verte de la couleur de la source de lumiere
							stoi(variable[5]),//composante bleue de la couleur de la source de lumiere
							stof(variable[6]));variable.clear();};//intensite de la source de lumiere
	
	if(ouverte=="obs"){S->setPosObservateur(
						stof(variable[0]));variable.clear();};//position sur l'axe z de l'observateur
	
      
	if(ouverte=="fenetre"){S->fixeFenetre(
					      stof(variable[0]),//abscisse du centre de la fenetre
					      stof(variable[1]),//ordonnee du centre de la fenetre
					      stof(variable[2]),//cote du centre de la fenetre
					      stoi(variable[3]),//largeur de la fenetre
					      stoi(variable[4]));variable.clear();};//hauteur de la fenetre
	
                       }
      break;
    default : 
      k=0,l=0;
      while(line[k]!='>')k++;
      param=line.substr(1,k-1); //rcupration du nom de la balise
      if(line.size()==param.size()+3){
	//ligne de type "<couleur>"
	balises.push(param);//empile param
	if(param=="scene"){S=new Scene();};
	
      }
      else {
	//ligne de type <nom>valeur</nom>
	while(line.substr(k+1,line.size())[l]!='<')l++;
	valeur=line.substr(k+1,l);//rcupration de la valeur
	if(line.substr(k+l+3,param.size())!=param){
	  syntaxe_erreur(nolig,line+"\n ne correspond pas  la derniere balise ouvrante");
	}
	else{
	  variable.push_back(valeur);//empile la valeur
	}       
      }
    }
    
  }
    return S; //on renvoi la scene creee
} 
