/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : point.h                          ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Point3D                                                        *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Un point3D possede en fait quatre coordonnees dans l'espace homogene  *   
*                                                                       *
************************************************************************/
#ifndef _POINT_H
#define _POINT_H

#include<iostream>

using namespace std;

class Point3D {

private :
	
	float X;		// abscisse
	float Y;		// ordonne
	float Z;		// hauteur
	float W;		// coordonne homogne

public :

	// constructeurs
	Point3D() {}; 
	Point3D(const Point3D &p) {X=p.X;Y=p.Y;Z=p.Z;W=p.W;};
	Point3D(const float &x, const float &y, const float &z) {X=x;Y=y;Z=z;W=1;};
	Point3D(const float &x, const float &y, const float &z, const float &w) {X=x;Y=y;Z=z;W=w;};

	// destructeur
	~Point3D() {};

	// accesseurs
	float getX() {return X;};
	float getY() {return Y;};
	float getZ() {return Z;};
	float getW() {return W;};

	// modificateurs
	void setX(const float &x) {X=x;};
	void setY(const float &y) {Y=y;};
	void setZ(const float &z) {Z=z;};
	void setW(const float &w) {W=w;};

	// affichage des coordonnes
	void afficherInfos() {
		cout<<"Coordonnees ("<<X<<","<<Y<<","<<Z<<","<<W<<")"<<endl;
	};

	// operateur ==
	bool operator == (Point3D p) {
	  return (X==p.getX() && Y==p.getY() && Z==p.getZ());
	}
	
	// engendrer un point  partir de l'quation paramtrique d'une sphre (teta, phi, rayon et centre)
	Point3D engendrerPoint(float t, float p, float r, Point3D centre_sph) {
	  float x = r * cos(p) * cos(t) + centre_sph.getX();
		float y = r * sin(p) + centre_sph.getY();
		float z = r * cos(p) * sin(t) + centre_sph.getZ();
		return Point3D(x,y,z);
	}

};


#endif
