/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : rayon.h                          ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Rayon                                                          *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Un rayon est un vecteur associe a un point d'origine                  *   
*                                                                       *
************************************************************************/

#ifndef _RAYON_H
#define _RAYON_H

#include<math.h>
#include"point.h"
#include"sphere.h"
#include"vecteur.h"
#include<iostream>
using namespace std;

class Rayon {

private :
  
  Point3D origine;		// origine du rayon
  Vecteur3D vectDir;		// vecteur directeur du rayon
  
public :

  // constructeurs
  Rayon() {};
  Rayon(const Point3D &p, const Vecteur3D &vd) {origine=p;vectDir=vd;};
  
  // destructeur
  ~Rayon() {};

  // accesseurs
  Point3D getOrigine() {return origine;};
  Vecteur3D getVectDir() {return vectDir;};

  // modificateurs
  void setOrigine(const Point3D &p) {origine=p;};
  void setVectDir(const Vecteur3D &vd) {vectDir=vd;};

  // calcul de l'intersection entre un rayon et une sphere
  // intersection avec une sphre "normale"
  // -> on renvoie le point d'intersection (NULL si inexistant)
  Point3D* hitSphere (Sphere * s);

  // intersection avec une sphre triangule
  // -> on renvoie un rayon (origine = intersection, vectDir = vecteur normal de la facette intersecte)
  // si pas d'intersection, origine = Point3D(0,0,0) et vectDir = Vecteur3D(0,0,0)
  Rayon hitSphereTriangulee (Sphere * s);

  // afficher informations
  void afficherInfos() {
    cout<<"- Rayon  . origine  ";origine.afficherInfos();
    cout<<"         . vect_dir ";vectDir.afficherInfos();
    cout<<endl;
  };

};

#endif
