/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : scene.cpp                        ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Scene                                                          *
*                                                                       *
*************************************************************************
* Description :                                                         *
* La scene concentre tout les informations relatives a une scene 3D.    *   
*                                                                       *
************************************************************************/

#include"scene.h"

// ajout d'une sphre
void Scene::ajoutSphere(float x, float y, float z, unsigned int r, unsigned int g, unsigned int b, float ray, float indM, float indD, float indS, int indR,int typT, int indT){
  Couleur c=Couleur(r,g,b);
  Point3D p=Point3D(x,y,z);
  Sphere *sp=new Sphere(p,ray,indM,indD,indS,indR,c,typT,indT);
  listeSpheres.push_back(sp);   
}

// ajout d'une source de lumire
void Scene::ajoutSrcLumiere(float x, float y, float z, unsigned int r, unsigned int g, unsigned int b, float intens){
  Couleur c=Couleur(r,g,b);
  Point3D p=Point3D(x,y,z);
  SrcLumiere sl=SrcLumiere(p,intens,c);
  listeSrcLumiere.push_back(sl);
}
     
// ajout de la fentre
void Scene::fixeFenetre(float x, float y, float z,int larg, int haut){
  Point3D pchg=Point3D(x,y,z);
  Fenetre f=Fenetre(pchg,larg,haut);
  setFenetre(f);
}

// affichage des donnes de la scne
void Scene::affiche_scene(){
  cout<<"Affichage scene "<<endl;
  int i;
  for(i =0;i<listeSpheres.size();++i){
    cout<<"sphere "<<i<<endl;
    listeSpheres[i]->afficherInfos();
    cout<<endl;
  }
  for(i =0;i<listeSrcLumiere.size();++i){
    cout<<"source lumiere "<<i<<endl;
    listeSrcLumiere[i].afficherInfos();
    cout<<endl;
  }
  cout<<"fenetre : "<<endl;
  fen.afficherInfos();     
  cout<<endl;
  cout<<"posObservateur "<<posObservateur<<endl;
  cout<<endl;
}

