/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : scene.h                          ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Scene                                                          *
*                                                                       *
*************************************************************************
* Description :                                                         *
* La scene concentre tout les informations relatives a une scene 3D.    *   
*                                                                       *
************************************************************************/


#ifndef _SCENE_H
#define _SCENE_H

#include"sphere.h"
#include"fenetre.h"
#include"srclumiere.h"
#include<vector>
#include<iostream>
using namespace std;

class Scene {

private :

	vector<Sphere*> listeSpheres;		// liste des sphres de la scne
	vector<SrcLumiere> listeSrcLumiere;	// liste des sources de lumire de la scne
	float posObservateur;			// position de l'observateur (fixe sur axe (Oz) --> une seule coordonne)
	Fenetre fen;				// fentre de la scne

public :

	// constructeurs
	Scene() {};
	Scene(const Scene &s) {
		listeSpheres=s.listeSpheres;
		listeSrcLumiere=s.listeSrcLumiere;
		posObservateur=s.posObservateur;
		fen=s.fen;};
	Scene(const vector<Sphere*> &ls, const vector<SrcLumiere> lsl, const float obs, const Fenetre f) {
		listeSpheres=ls;
		listeSrcLumiere=lsl;
		posObservateur=obs;
		fen=f;};

	// destructeur
	~Scene() {listeSpheres.clear();listeSrcLumiere.clear();};

	// accesseurs
	vector<Sphere*> getListeSpheres() {return listeSpheres;};
	vector<SrcLumiere> getListeSrcLumiere() {return listeSrcLumiere;};
	float getPosObservateur() {return posObservateur;};
	Fenetre getFenetre() {return fen;};

	// modificateurs
	void setListeSpheres(const vector<Sphere*> &ls) {listeSpheres=ls;};
	void setListeSrcLumiere(const vector<SrcLumiere> &lsl) {listeSrcLumiere=lsl;};
	void setPosObservateur(const float &obs) {posObservateur=obs;};
	void setFenetre(const Fenetre &f) {fen=f;};

	// mthodes utilises par le parser
	// ajout d'une sphre
	void ajoutSphere(float x, float y, float z, unsigned int r, unsigned int g, unsigned int b, float ray, float indM, float indD, float indS, int indR,int typT, int indT);
	// ajout d'une source de lumire
	void ajoutSrcLumiere(float x, float y, float z, unsigned int r, unsigned int g, unsigned int b, float intens);
	// ajout de la fentre
	void fixeFenetre(float x, float y, float z,int larg, int haut);
	
	// affichage de la scne
	void affiche_scene();     
};

#endif
