/************************************************************************
*************************************************************************
****                                                                 ****
****                       Projet : LANCER DE RAYON                  ****
****                      fichier : triangle.h                       ****
****                                                                 ****
*************************************************************************
*************************************************************************
* Auteurs :                               date : 12/05/05               *
*          GUITTENY Fabrice                                             *
*          LE GOFF Erwan                                                *
*          LAHUEC Morgan                                                *
*************************************************************************
* Class: Triangle                                                       *
*                                                                       *
*************************************************************************
* Description :                                                         *
* Un triangle est represente par 3 points et une couleur                *   
*                                                                       *
************************************************************************/

#ifndef _TRIANGLE_H
#define _TRIANGLE_H

#include"point.h"
#include"couleur.h"
#include<iostream>
using namespace std;

class Triangle {

private :
	
	Point3D pA;		// 1er point du traiangle
	Point3D pB;		// 2me point du triangle
	Point3D pC;		// 3me point du triangle
	Couleur couleur;	// couleur du triangle

public :

	// constructeurs
	Triangle() {};
	Triangle(const Triangle &t) {pA=t.pA;pB=t.pB;pC=t.pC;};
	Triangle(const Point3D &a, const Point3D &b, const Point3D &c) {
		pA=a;
		pB=b;
		pC=c;
		// pas de couleur par dfaut
		couleur=Couleur();
	};
	Triangle(const Point3D &a, const Point3D &b, const Point3D &c, const Couleur &coul) {
		pA=a;
		pB=b;
		pC=c;
		couleur=coul;
	};
	Triangle(Point3D *a, Point3D *b, Point3D *c, const Couleur &coul) {
		pA=*a;
		pB=*b;
		pC=*c;
		couleur=coul;
	};
	Triangle(Point3D *a, Point3D *b, Point3D *c) {
		pA=*a;
		pB=*b;
		pC=*c;
		couleur=Couleur();
	};
	// destructeur
	~Triangle() {};

	// accesseurs
	Point3D getPointA() {return pA;};
	Point3D getPointB() {return pB;};
	Point3D getPointC() {return pC;};
	Couleur getCouleur() {return couleur;};

	// modificateurs
	void setPointA(const Point3D &a) {pA=a;};
	void setPointB(const Point3D &b) {pB=b;};
	void setPointC(const Point3D &c) {pC=c;};
	void setCouleur(const Couleur &coul) {couleur=coul;}; 

	// autres mthodes
	void afficherInfos() {
		cout<<"Points :"<<endl;
		pA.afficherInfos();
		pB.afficherInfos();
		pC.afficherInfos();
	};

};

#endif
